﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Activities;

// Demo by Raffaele Rialdi. May 20, 2010
// http://www.iamraf.net
// malta@vevy.com

namespace StateMachineUI
{
	public class StateInfoActivity : NativeActivity<string>
	{
		public static readonly string StateUnlocker = "raf";

		protected override bool CanInduceIdle
		{
			get { return true; }
		}

		protected override void Execute(NativeActivityContext context)
		{
			context.CreateBookmark(StateUnlocker, new BookmarkCallback(OnStateReceived));
		}

		void OnStateReceived(NativeActivityContext ctx, Bookmark bookmark, object state)
		{
			// lo stato a cui fare la transizione arriva come parametro
			string input = state as string;
			ctx.SetValue(this.Result, input);
			ctx.RemoveBookmark(bookmark);
		}

	}
}
